import json
import matplotlib.pyplot as plt
import numpy as np
import pandas
import seaborn
from plot_utils import *
import os
smooth_rate = 10

def plot_single_task(task_name):
	# task_name = task_name.split('_')[1]



	original_reward, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/' + task_name + '/original_reward_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/' + task_name + '/original_reward_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/' + task_name + '/original_reward_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv',],smooth_rate)
	original_reward, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/' + task_name + '/original_reward_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/' + task_name + '/original_reward_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/' + task_name + '/original_reward_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal10, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/' + task_name + '/opal10_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/' + task_name + '/opal10_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/' + task_name + '/opal10_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv',],
		smooth_rate)
	random, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/' + task_name + '/random_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/' + task_name + '/random_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/' + task_name + '/random_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	if task_name in ["hopper-random-v2", "hopper-medium-expert-v2", "hopper-medium-replay-v2", "hopper-medium-v2", "walker2d-medium-replay-v2", "walker2d-medium-v2"]:
		original_reward, soft_length = read_data_csv_analyse([  # top500
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/true2_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/true2_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/true2_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
			smooth_rate)
		opal10, soft_length = read_data_csv_analyse([  # top500
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/opal2_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/opal2_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/opal2_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
			smooth_rate)
	if task_name in ["hopper-random-v2", "hopper-medium-v2"]:
		random, soft_length = read_data_csv_analyse([  # top500
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/random2_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/random2_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/random2_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
			smooth_rate)

	# opal102, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results/' + task_name + '/opaltruefixed_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results/' + task_name + '/opaltruefixed_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results/' + task_name + '/opaltruefixed_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)

	# pthd10qeries_hd
	datas = [original_reward, random, opal10]
	# datas = [original_reward,pthd10qeries,pthd10qeries_hd_799,pthd10qeries_hd_positive,opal]

	# datas = [original_reward,original_reward_hd_07099,pthd10qeries,pthd10qeries_hd_799,random,pthd100qeries,pthd100qeries_hd_799]
	# dataset_name = task_name
	# true_data = np.load('./data/'+dataset_name+'/data_randgoal_08_50_08_batch.npy',allow_pickle=True).tolist()
	# max_return = 1
	# for i in range(1000):
	# 	current_return = np.sum([true_data['rewards'][i*500:(i+1)*500]])
	# 	max_return = max(max_return,current_return)
	max_return=1
	means,distances = [],[]
	print(task_name)
	# max_return = 1
	for i in range(len(datas)):
		mean = np.mean(datas[i][0][-10:])
		interval_distance = np.mean(datas[i][1][-10:])
		means.append(mean/ max_return)
		distances.append(interval_distance/ max_return)
	print(['%.2f$~\pm~$%.2f & ' % (m, d ) for (m, d) in zip(means, distances)])
	return means,distances

def plot_single_task2(task_name):
	# task_name = task_name.split('_')[1]

# "/data3/zj/optimal_transport_reward/ptresults_138/tb/antmaze-umaze-diverse-v2/original/original_reward/785"

	original_reward, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/' + task_name + '/original/original_reward/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/' + task_name + '/original/original_reward/786/progress.txt','/data3/zj/optimal_transport_reward/ptresults_138/tb/' + task_name + '/original/original_reward/787/progress.txt',],smooth_rate)
	opal10, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/' + task_name + '/original/opal10_fix/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/' + task_name + '/original/opal10_fix/786/progress.txt','/data3/zj/optimal_transport_reward/ptresults_138/tb/' + task_name + '/original/opal10_fix/787/progress.txt',],
		smooth_rate)
	if 'walker2d' not in task_name:
		import os
		listw=os.listdir('/data3/zj/IQL-PyTorch/results/opal10/' + task_name)
		opal10, soft_length = read_data_csv_analyse3([
			'/data3/zj/IQL-PyTorch/results/opal10/' + task_name + '/'+s+'/progress.csv' for s in listw],
			smooth_rate)
		listw=os.listdir('/data3/zj/IQL-PyTorch/results/opal104/' + task_name)
		opal10, soft_length = read_data_csv_analyse3([
			'/data3/zj/IQL-PyTorch/results/opal104/' + task_name + '/'+s+'/progress.csv' for s in listw],
			smooth_rate)
	# opal102 , soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results/' + task_name + '/opaltruefixed_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results/' + task_name + '/opaltruefixed_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results/' + task_name + '/opaltruefixed_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv',],
	# 	smooth_rate)
	random, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/' + task_name + '/random_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/' + task_name + '/random_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/' + task_name + '/random_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	if task_name in ["hopper-random-v2",  "hopper-medium-expert-v2", "hopper-medium-replay-v2", "hopper-medium-v2", "walker2d-medium-replay-v2", "walker2d-medium-v2"]:
		original_reward, soft_length = read_data_csv_analyse([  # top500
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/true2_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/true2_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/true2_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
			smooth_rate)
		opal10, soft_length = read_data_csv_analyse([  # top500
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/opal2_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/opal2_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results/' + task_name + '/opal2_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
			smooth_rate)
	# pthd10qeries_hd
	datas = [original_reward,random,opal10]
	# datas = [original_reward,pthd10qeries,pthd10qeries_hd_799,pthd10qeries_hd_positive,opal]

	# datas = [original_reward,original_reward_hd_07099,pthd10qeries,pthd10qeries_hd_799,random,pthd100qeries,pthd100qeries_hd_799]
	# dataset_name = task_name
	# true_data = np.load('./data/'+dataset_name+'/data_randgoal_08_50_08_batch.npy',allow_pickle=True).tolist()
	# max_return = 1
	# for i in range(1000):
	# 	current_return = np.sum([true_data['rewards'][i*500:(i+1)*500]])
	# 	max_return = max(max_return,current_return)
	max_return=1
	means,distances = [],[]
	print(task_name)
	# max_return = 1
	for i in range(len(datas)):
		mean = np.mean(datas[i][0][-10:])
		interval_distance = np.mean(datas[i][1][-10:])
		if ('walker' in task_name and i!=1) or ('maze2d' in task_name and i==0):
			import d4rl,gym,d4rl.gym_mujoco
			env=gym.make(task_name)
			mean=env.get_normalized_score(mean)
			interval_distance=env.get_normalized_score(interval_distance)
		means.append(mean/ max_return)
		distances.append(interval_distance/ max_return)
	print(['%.2f$~\pm~$%.2f & ' % (m, d ) for (m, d) in zip(means, distances)])
	return means,distances
	# print("%.2f", % average_return)
	# plot_fig_save([ original_reward,learned50,ones,opal], [0, 1, 2, 3, 4, 5, 6, 7,8,9],
	# 				   ['Original Reward','Ours random 50','Ones','OPAL'],'Return',task_name)

# def plot_single_task_2(task_name):
# 	task_name = task_name.split('_')[1]
# 	original_reward, soft_length = read_data_csv([
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_285/logs/eval_loop/logs.csv',
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_286/logs/eval_loop/logs.csv','/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_287/logs/eval_loop/logs.csv', ],
# 												 smooth_rate)
# 	learned50, soft_length = read_data_csv([
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_385/logs/eval_loop/logs.csv',
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_386/logs/eval_loop/logs.csv','/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_387/logs/eval_loop/logs.csv', ],
# 												 smooth_rate)
#
# 	ones, soft_length = read_data_csv([
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_385/logs/eval_loop/logs.csv',
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_386/logs/eval_loop/logs.csv',
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_387/logs/eval_loop/logs.csv', ],
# 		smooth_rate)
#
#
# 	plot_fig_save([ original_reward,learned50,ones], [0, 1, 2, 3, 4, 5, 6, 7,8,9],
# 					   ['Original Reward','Ours random 50','Ones'],'Return',task_name)

if __name__=='__main__':
	#, "metaworld_button-press-topdown-wall-v2"286#, "metaworld_dial-turn-v2"287 # , "metaworld_button-press-wall-v2", 285-287
	# "metaworld_shelf-place-v2", "metaworld_stick-pull-v2"
	names=["hopper-random-v2", "hopper-medium-expert-v2", "hopper-medium-replay-v2", "hopper-medium-v2", "hopper-expert-v2" ,"halfcheetah-random-v2", "halfcheetah-medium-expert-v2", "halfcheetah-medium-replay-v2", "halfcheetah-medium-v2", "halfcheetah-expert-v2",  "ant-random-v2", "ant-medium-expert-v2", "ant-medium-replay-v2", "ant-medium-v2", "ant-expert-v2", "walker2d-random-v2" , "walker2d-medium-replay-v2", "walker2d-medium-v2", "walker2d-expert-v2"   ]
	# names=["hopper-random-v2", "hopper-medium-expert-v2", "hopper-medium-replay-v2", "hopper-medium-v2", "hopper-expert-v2"]
	# hopper-random-v2 hopper-medium-v2
	# names.remove("ant-random-v2")
	# names.remove("ant-medium-expert-v2")
	# names.remove("ant-medium-v2")
	# names.remove("ant-expert-v2")
	# hopper-random-v2  hopper-medium-expert-v2 hopper-medium-replay-v2 hopper-medium-v2 walker2d-medium-replay-v2 walker2d-medium-v2
	# names.remove("walker2d-random-v2")
	# names.remove("walker2d-medium-v2")
	# names.remove("walker2d-expert-v2")
# "walker2d-medium-expert-v2","antmaze-medium-diverse-v2" ,"antmaze-medium-play-v2", "antmaze-large-diverse-v2", "antmaze-large-play-v2", "antmaze-umaze-diverse-v2", "antmaze-umaze-v2","maze2d-open-v0" ,"maze2d-umaze-v1","maze2d-medium-v1", "maze2d-large-v1", "maze2d-open-dense-v0", "maze2d-umaze-dense-v1", "maze2d-medium-dense-v1" ,"maze2d-large-dense-v1"
	# names+=[ "metaworld_door-lock-v2", "metaworld_door-open-v2", "metaworld_door-unlock-v2", "metaworld_drawer-close-v2", "metaworld_drawer-open-v2", "metaworld_faucet-close-v2", ,]
	# names+=["metaworld_faucet-open-v2","metaworld_hammer-v2", "metaworld_hand-insert-v2", "metaworld_handle-press-side-v2", "metaworld_handle-press-v2", "metaworld_handle-pull-side-v2", "metaworld_handle-pull-v2", ,"metaworld_lever-pull-v2",  ]
	# names+=["metaworld_peg-insert-side-v2", "metaworld_peg-unplug-side-v2", "metaworld_pick-out-of-hole-v2", ,"metaworld_pick-place-v2", "metaworld_pick-place-wall-v2", ,"metaworld_plate-slide-back-side-v2", ,"metaworld_plate-slide-back-v2",  ]
	# names+=["metaworld_plate-slide-side-v2", "metaworld_plate-slide-v2", "metaworld_push-back-v2",  "metaworld_push-v2", ,"metaworld_push-wall-v2", "metaworld_reach-v2", ,"metaworld_reach-wall-v2",  ]
	# names+=[ "metaworld_soccer-v2", "metaworld_stick-push-v2",  ,"metaworld_sweep-v2",  "metaworld_sweep-into-v2", "metaworld_window-close-v2", "metaworld_window-open-v2",  ]
	# names += ["metaworld_button-press-topdown-wall-v2", "metaworld_dial-turn-v2", "metaworld_button-press-wall-v2",
	# 		   "metaworld_shelf-place-v2", "metaworld_stick-pull-v2"]
	# names.remove("metaworld_door-lock-v2")
	# names.remove("metaworld_door-open-v2")
	# names.remove("metaworld_door-unlock-v2")
	# names.remove("metaworld_faucet-close-v2")
	# names.remove("metaworld_faucet-open-v2")
	# names.remove("metaworld_handle-pull-side-v2")
	# names.remove("metaworld_lever-pull-v2")
	# names.remove("metaworld_plate-slide-back-v2")
	# names.remove("metaworld_window-close-v2")
	# names.remove("metaworld_stick-pull-v2")
	means_all,distances_all = [],[]
	for n in names:
		m,d=plot_single_task(n)
		means_all.append(m)
		distances_all.append(d)
	names2=["walker2d-medium-expert-v2","antmaze-medium-diverse-v2" ,"antmaze-medium-play-v2", "antmaze-large-diverse-v2", "antmaze-large-play-v2", "antmaze-umaze-diverse-v2", "antmaze-umaze-v2"]#,"maze2d-open-v0" ,"maze2d-umaze-v1","maze2d-medium-v1", "maze2d-large-v1", "maze2d-open-dense-v0", "maze2d-umaze-dense-v1", "maze2d-medium-dense-v1" ,"maze2d-large-dense-v1"
	# names2=[]
	for n in names2:
		m,d=plot_single_task2(n)
		means_all.append(m)
		distances_all.append(d)
	means_all,distances_all=np.array(means_all),np.array(distances_all)
	print(means_all.shape)
	print(np.mean(means_all,0),np.mean(distances_all,0))
	# for i in len(means_all[0]):


	# names2=[]
	# names2+=["metaworld_button-press-topdown-wall-v2", "metaworld_dial-turn-v2", ,"metaworld_button-press-wall-v2", ,"metaworld_shelf-place-v2", ,"metaworld_stick-pull-v2"]
	# for n in names2:
	# 	plot_single_task(n)