import json
import matplotlib.pyplot as plt
import numpy as np
import pandas
import seaborn
from plot_utils import *
import os
smooth_rate = 30

def plot_single_task(task_name):
	task_name = task_name.split('_')[1]



	original_reward, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right/787/progress.txt', ],
		smooth_rate)
	original_reward_hd_07099, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd2_07099/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd2_07099/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd2_07099/787/progress.txt', ],
		smooth_rate)

	pthd10qeries_hd_799, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd2_07099/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd2_07099/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd2_07099/787/progress.txt', ],
		smooth_rate)
	pthd10qeries, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queries_pt_08_50_08/585/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queries_pt_08_50_08/586/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queries_pt_08_50_08/587/progress.txt','/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd_positive/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd_positive/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd_positive/787/progress.txt',  ],
		smooth_rate)

	pthd100qeries_hd_799, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd_positive/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd_positive/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd_positive/787/progress.txt', ],
		smooth_rate)
	pthd100qeries_hd2_799, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd/787/progress.txt', ],
		smooth_rate)
	pthd100qeries, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries/787/progress.txt', ],
		smooth_rate)
	random, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_random/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_random/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_random/787/progress.txt', ],
		smooth_rate)
	opal, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal/787/progress.txt', ],
		smooth_rate)
	opal_hd, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal_hd/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal_hd/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal_hd/787/progress.txt', ],
		smooth_rate)
	top10bc, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/TD3_BC/results/TD3_BC_metaworld_' + task_name + '_385.npy',
		'/data3/zj/TD3_BC/results/TD3_BC_metaworld_' + task_name + '_386.npy','/data3/zj/TD3_BC/results/TD3_BC_metaworld_' + task_name + '_387.npy', ],
		smooth_rate)
	opal_hd2, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10_hd2_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10_hd2_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10_hd2_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal_hd3, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_hd_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_hd_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_hd_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal2, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)


	oppo, soft_length = read_data_npy_analyse2([  # top500
		'/data3/zj/OPPO/oppo/human/gym/results/' + task_name + '_385.npy',
		'/data3/zj/OPPO/oppo/human/gym/results/' + task_name + '_386.npy','/data3/zj/OPPO/oppo/human/gym/results/' + task_name + '_387.npy', ],
		3)#'/data3/zj/OPPO/oppo/human/gym/results/assembly-v2_385.npy'

	opal3, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_use_dataset_rewards_0_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_use_dataset_rewards_0_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_use_dataset_rewards_0_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	otr, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/otr_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/otr_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/otr_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	if 'metaworld_'+task_name not in ["metaworld_pick-out-of-hole-v2" ,"metaworld_pick-place-v2", "metaworld_pick-place-wall-v2" ,"metaworld_plate-slide-back-side-v2" ,"metaworld_plate-slide-back-v2", "metaworld_plate-slide-side-v2", "metaworld_plate-slide-v2" ,"metaworld_push-back-v2" , "metaworld_push-v2" ,"metaworld_push-wall-v2" ,"metaworld_reach-v2", "metaworld_reach-wall-v2",  "metaworld_shelf-place-v2", "metaworld_soccer-v2", "metaworld_stick-pull-v2", "metaworld_stick-push-v2",  "metaworld_sweep-v2",  "metaworld_sweep-into-v2", "metaworld_window-close-v2", "metaworld_window-open-v2"]:
		opal_hdnew, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_use_dataset_rewards_0_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_use_dataset_rewards_0_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_use_dataset_rewards_0_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	else:
		opal_hdnew, soft_length = read_data_csv_analyse([  # top500
			'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_hd_use_dataset_rewards_0_seed_785/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_hd_use_dataset_rewards_0_seed_786/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_hd_use_dataset_rewards_0_seed_787/logs/eval_loop/logs.csv', ],
			smooth_rate)


	# pthd40qeries_hd_799, soft_length = read_data_txt_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40testhd/785/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40testhd/786/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40testhd/787/progress.txt', ],
	# 	smooth_rate)
	# pthd40qeries, soft_length = read_data_txt_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40/785/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40/786/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40/787/progress.txt', ],
	# 	smooth_rate)
	# pthd70qeries_hd_799, soft_length = read_data_txt_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT70testhd2/785/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT70testhd2/786/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT70testhd2/787/progress.txt', ],
	# 	smooth_rate)
	# pthd70qeries, soft_length = read_data_txt_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT70test/785/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT70test/786/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT70test/787/progress.txt', ],
	# 	smooth_rate)
	cuttop70, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queriescut/385/progress.txt',
		'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queriescut/386/progress.txt','/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queriescut/387/progress.txt', ],
		smooth_rate)
	# pthd10qeries_hd


	pthd40, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PThd40/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PThd40/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PThd40/787/progress.txt', ],
		smooth_rate)
	pthd70, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd70/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd70/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd70/787/progress.txt', ],
		smooth_rate)
	pthd100, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PThd100/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PThd100/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PThd100/787/progress.txt', ],
		smooth_rate)
	pt40, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pt40/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pt40/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pt40/787/progress.txt', ],
		smooth_rate)
	pt70, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pt70/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pt70/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pt70/787/progress.txt', ],
		smooth_rate)
	pt100, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pt100/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pt100/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PThd100/787/progress.txt', ],
		smooth_rate)
	#/data3/zj/lightATAC/results/sweep-v2_385opal10.npy
	atacori, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/lightATAC/results/' + task_name + '_585opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_586opal10.npy','/data3/zj/lightATAC/results/' + task_name + '_587opal10.npy',],
		3)
	atacori2, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/lightATAC/results/' + task_name + '_685opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_686opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_687opal10.npy', ],
		3)
	atacopal2, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/lightATAC/results/' + task_name + '_885opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_886opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_887opal10.npy', ],
		3)
	atacopalhd2, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/lightATAC/results/' + task_name + '_985opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_986opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_987opal10.npy', ],
		3)
	atacori3, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/lightATAC/results/' + task_name + '_785opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_786opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_787opal10.npy', ],
		3)
	atacopal10, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/lightATAC/results/' + task_name + '_385opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_386opal10.npy','/data3/zj/lightATAC/results/' + task_name + '_387opal10.npy',],
		3)
	atacopal10hd, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/lightATAC/results/' + task_name + '_485opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_486opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_487opal10.npy', ],
		3)
	atacopal10hd3, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/lightATAC/results/' + task_name + '_1085opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_1086opal10.npy',
		'/data3/zj/lightATAC/results/' + task_name + '_1087opal10.npy', ],
		3)

	pthd700_08, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd700_082/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd700_082/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd700_082/787/progress.txt', ],
		smooth_rate)

	pthd800_07, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd800_072/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd800_072/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd800_072/787/progress.txt', ],
		smooth_rate)

	pthd800_08, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd800_082/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd800_082/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/pthd800_082/787/progress.txt', ],
		smooth_rate)

	opal40,s=read_data_csv_analyse([
	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_'+task_name+'/opal40_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_'+task_name+'/opal40_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv','/data3/zj/optimal_transport_reward/results_138/results/metaworld_'+task_name+'/opal40_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ], smooth_rate)
	opal70, s = read_data_csv_analyse([
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal70_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal70_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal70_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal100, s = read_data_csv_analyse([
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)

	opal40hd, s = read_data_csv_analyse([
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal40hd_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal40hd_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal40hd_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal70hd, s = read_data_csv_analyse([
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal70hd_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal70hd_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal70hd_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal100hd, s = read_data_csv_analyse([
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100hd_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100hd_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100hd_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal10, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)

	opal10hd, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_hd_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_hd_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_hd_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)

	opal900_07, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal900_07_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal900_07_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal900_07_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal900_08, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal900_08_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal900_08_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal900_08_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal700_08, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal700_08_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal700_08_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal700_08_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal700_052, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal700_052_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal700_052_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal700_052_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal500_052, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal500_052_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal500_052_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal500_052_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal500_072, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal500_072_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal500_072_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal500_072_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal1002, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal1002_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal1002_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal1002_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal2002, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal2002_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal2002_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal2002_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal5002, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal5002_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal5002_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal5002_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)

	originalhd, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/orihd3_use_dataset_rewards_1_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/orihd3_use_dataset_rewards_1_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/orihd3_use_dataset_rewards_1_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	originalhd4, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/orihd4_use_dataset_rewards_1_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/orihd4_use_dataset_rewards_1_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/orihd4_use_dataset_rewards_1_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	# opalhd1002, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd1002_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd1002_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd1002_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	opalhd1003, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd1003_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd1003_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd1003_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opalhd2003, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd2003_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd2003_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd2003_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opalhd5003, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd5003_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd5003_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd5003_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)

	originalhd2, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/pthdnew3/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/pthdnew3/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/pthdnew3/787/progress.txt', ],
		smooth_rate)
	if task_name in ['box-close-v2','drawer-open-v2','handle-pull-side-v2','reach-wall-v2','sweep-into-v2']:
		original_reward_hd_07099, soft_length = read_data_txt_analyse([  # top500
			'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd2_07099/785/progress.txt',
			'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd2_07099/786/progress.txt',
			'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd2_07099/787/progress.txt','/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/pthdnew3/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/pthdnew3/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/pthdnew3/787/progress.txt', ],
			smooth_rate)
	# opalhd2002, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd2002_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd2002_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd2002_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	# opalhd5002, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd5002_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd5002_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd5002_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	# opal1002, s = read_data_csv_analyse([
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100hd_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100hd_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100hd_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	# opal100hd, s = read_data_csv_analyse([
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100hd_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100hd_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal100hd_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	# datas = [original_reward,opal2,opal_hd3,pthd10qeries,pthd10qeries_hd_799]
	# datas = [original_reward,pthd10qeries,pthd10qeries_hd_799,pthd10qeries_hd_positive,opal]
	# datas=[original_reward,original_reward_hd_07099,pthd10qeries,pthd10qeries_hd_799,pt40,pthd40,pt70,pthd70,pt100,pthd100]
	datas=[atacori,atacopal10,atacopal10hd,atacori2,atacori3,original_reward]
	# datas=[original_reward,pthd10qeries,cuttop70]
	# datas=[original_reward,opal10,opal10hd,opal500_072,opal700_052,opal500_052]
	datas=[opal10,opal10hd,opal1002,opalhd1003,opal2002,opalhd2003,opal5002,opalhd5003,original_reward,original_reward_hd_07099,]
	datas=[opal5002,opalhd5003,original_reward,original_reward_hd_07099]
	datas=[opal5002,opalhd5003,original_reward,original_reward_hd_07099]
	datas=[pthd10qeries,pthd10qeries_hd_799,cuttop70]
	datas=[original_reward,originalhd4]
	datas=[original_reward,pthd10qeries,pthd10qeries_hd_799,original_reward_hd_07099,originalhd2]
	datas=[atacori2,atacopal2,atacopal10hd3]
	# datas=[original_reward,pthd10qeries,pthd10qeries_hd_799,pthd700_08,pthd800_07,pthd800_08]
	# datas=[opal10,opal10hd,opal40,opal40hd,opal70,opal70hd,opal100,opal100hd,original_reward,original_reward_hd_07099]
	# datas = [original_reward,original_reward_hd_07099,pthd10qeries,pthd10qeries_hd_799,random,pthd100qeries,pthd100qeries_hd_799]
	dataset_name = task_name
	true_data = np.load('./data/'+dataset_name+'/data_randgoal_08_50_08_batch.npy',allow_pickle=True).tolist()
	max_return = 1
	for i in range(1000):
		current_return = np.sum([true_data['rewards'][i*500:(i+1)*500]])
		max_return = max(max_return,current_return)

	means,distances = [],[]
	print(dataset_name)
	# max_return = 1
	for i in range(len(datas)):
		mean = np.mean(datas[i][0][-20:])
		interval_distance = np.mean(datas[i][1][-20:])
		means.append(mean/ max_return)
		distances.append(interval_distance/ max_return)
	print(['%.2f$~\pm~$%.2f & ' % (m, d ) for (m, d) in zip(means, distances)])
	return means,distances
	# print("%.2f" % average_return)
	# plot_fig_save([ original_reward,learned50,ones,opal], [0, 1, 2, 3, 4, 5, 6, 7,8,9],
	# 				   ['Original Reward','Ours random 50','Ones','OPAL'],'Return',task_name)

# def plot_single_task_2(task_name):
# 	task_name = task_name.split('_')[1]
# 	original_reward, soft_length = read_data_csv_analyse([
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_285/logs/eval_loop/logs.csv',
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_286/logs/eval_loop/logs.csv','/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_287/logs/eval_loop/logs.csv', ],
# 												 smooth_rate)
# 	learned50, soft_length = read_data_csv_analyse([
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_385/logs/eval_loop/logs.csv',
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_386/logs/eval_loop/logs.csv','/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_387/logs/eval_loop/logs.csv', ],
# 												 smooth_rate)
#
# 	ones, soft_length = read_data_csv_analyse([
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_385/logs/eval_loop/logs.csv',
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_386/logs/eval_loop/logs.csv',
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_387/logs/eval_loop/logs.csv', ],
# 		smooth_rate)
#
#
# 	plot_fig_save([ original_reward,learned50,ones], [0, 1, 2, 3, 4, 5, 6, 7,8,9],
# 					   ['Original Reward','Ours random 50','Ones'],'Return',task_name)

if __name__=='__main__':
	#, "metaworld_button-press-topdown-wall-v2"286#, "metaworld_dial-turn-v2"287 # , "metaworld_button-press-wall-v2" 285-287
	# "metaworld_shelf-place-v2", "metaworld_stick-pull-v2"
	names=["metaworld_box-close-v2", "metaworld_drawer-open-v2", "metaworld_hammer-v2", "metaworld_handle-pull-side-v2", "metaworld_sweep-v2",  "metaworld_pick-place-v2", "metaworld_plate-slide-back-v2", "metaworld_push-v2", "metaworld_reach-wall-v2", "metaworld_sweep-into-v2",]


	means_all,distances_all = [],[]
	for n in names:
		m,d=plot_single_task(n)
		means_all.append(m)
		distances_all.append(d)
	means_all,distances_all=np.array(means_all),np.array(distances_all)
	print(means_all.shape)
	print(np.mean(means_all,0),np.mean(distances_all,0))
	# for i in len(means_all[0]):


	# names2=[]
	# names2+=["metaworld_button-press-topdown-wall-v2", "metaworld_dial-turn-v2" ,"metaworld_button-press-wall-v2" ,"metaworld_shelf-place-v2" ,"metaworld_stick-pull-v2"]
	# for n in names2:
	# 	plot_single_task(n)

