import json
import matplotlib.pyplot as plt
import numpy as np
import pandas
import seaborn
from plot_utils import *
import os
smooth_rate = 30

def plot_single_task(task_name):
	task_name = task_name.split('_')[1]


	# original_reward, soft_length = read_data_txt_analyse([
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward/385/progress.txt',
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward/386/progress.txt',
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward/387/progress.txt', ],
	# 	smooth_rate)
	original_reward, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right/787/progress.txt', ],
		smooth_rate)
	# original_reward_hd, soft_length = read_data_txt_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd/785/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd/786/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd/787/progress.txt', ],
	# 	smooth_rate)
	original_reward_hd_07099, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd2_07099/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd2_07099/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_fixed_original_reward_right_hd2_07099/787/progress.txt', ],
		smooth_rate)
	# random_reward, soft_length = read_data_txt_analyse([
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_random/285/progress.txt',
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_random/286/progress.txt',
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_random/287/progress.txt', ],
	# 	smooth_rate)
	# original_reward_hd, soft_length = read_data_txt_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/original_reward_hd_08_50_08/585/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/original_reward_hd_08_50_08/586/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/original_reward_hd_08_50_08/587/progress.txt', ],
	# 	smooth_rate)
	# random_reward, soft_length = read_data_txt_analyse([
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_random/285/progress.txt',
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_random/286/progress.txt',
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_random/287/progress.txt', ],
	# 	smooth_rate)

	# pthd30qeries_hd, soft_length = read_data_txt_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/30queries_pthd_08_50_08/585/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/30queries_pthd_08_50_08/586/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/30queries_pthd_08_50_08/587/progress.txt', ],
	# 	smooth_rate)
	# pthd30qeries, soft_length = read_data_txt_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/30queries_pt_08_50_08/585/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/30queries_pt_08_50_08/586/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/30queries_pt_08_50_08/587/progress.txt', ],
	# 	smooth_rate)
	pthd10qeries_hd, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queries_pthd_08_50_08/585/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queries_pthd_08_50_08/586/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queries_pthd_08_50_08/587/progress.txt', ],
		smooth_rate)
	pthd10qeries_hd_799, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd2_07099/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd2_07099/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd2_07099/787/progress.txt', ],
		smooth_rate)
	pthd10qeries_hd_positive, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd_positive2/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd_positive2/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd_positive2/787/progress.txt', ],
		smooth_rate)
	pthd10qeries, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queries_pt_08_50_08/585/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queries_pt_08_50_08/586/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queries_pt_08_50_08/587/progress.txt','/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd_positive/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd_positive/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_hd_positive/787/progress.txt',  ],
		smooth_rate)

	pthd100qeries_hd_799, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd_positive/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd_positive/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd_positive/787/progress.txt', ],
		smooth_rate)
	pthd100qeries_hd2_799, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries_hd/787/progress.txt', ],
		smooth_rate)
	pthd100qeries, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_100queries/787/progress.txt', ],
		smooth_rate)
	random, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_random/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_random/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_random/787/progress.txt', ],
		smooth_rate)
	pthd100queries2, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_opal/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_opal/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/08_50_08_10queries_opal/787/progress.txt', ],
		smooth_rate)
	opal, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/logs/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal/787/progress.txt', ],
		smooth_rate)
	opal_hd, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal_hd/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal_hd/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/original/08_50_08_10queries_opal_hd/787/progress.txt', ],
		smooth_rate)
	top10bc, soft_length = read_data_npy_analyse([  # top500
		'/data3/zj/TD3_BC/results/TD3_BC_metaworld_' + task_name + '_385.npy',
		'/data3/zj/TD3_BC/results/TD3_BC_metaworld_' + task_name + '_386.npy','/data3/zj/TD3_BC/results/TD3_BC_metaworld_' + task_name + '_387.npy', ],
		smooth_rate)
	opal_hd2, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10_hd2_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10_hd2_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10_hd2_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal_hd3, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_hd_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_hd_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_hd_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	# opal_hd599, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_599_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_599_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_599_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	opal2, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)

	opal3, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_2_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_2_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10_2_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal3, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal40_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal40_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal40_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal3, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal13_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal13_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal13_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	oppo, soft_length = read_data_npy_analyse2([  # top500
		'/data3/zj/OPPO/oppo/human/gym/results/' + task_name + '_385.npy',
		'/data3/zj/OPPO/oppo/human/gym/results/' + task_name + '_386.npy','/data3/zj/OPPO/oppo/human/gym/results/' + task_name + '_387.npy', ],
		3)#'/data3/zj/OPPO/oppo/human/gym/results/assembly-v2_385.npy'
	# opal3, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10159_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10159_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/opal10159_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	# opal3, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal101371_use_dataset_rewards_0_seed_785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal101371_use_dataset_rewards_0_seed_786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal101371_use_dataset_rewards_0_seed_787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	opal3, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_use_dataset_rewards_0_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_use_dataset_rewards_0_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_use_dataset_rewards_0_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal_hdnew, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal700_fix_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal700_fix_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal700_fix_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal_hdnew, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal13hd_fix599_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal13hd_fix599_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal13hd_fix599_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	opal3, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_use_dataset_rewards_0_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_use_dataset_rewards_0_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_use_dataset_rewards_0_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	otr, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/otr_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/otr_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/otr_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	# opal3, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed2_use_dataset_rewards_0_seed_1785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed2_use_dataset_rewards_0_seed_1786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed2_use_dataset_rewards_0_seed_1787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	# opal3, soft_length = read_data_txt_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_MR/MR10/785/progress.txt',
	# 	'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_MR/MR10/786/progress.txt','/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_MR/MR10/787/progress.txt', ],
	# 	smooth_rate)
	if 'metaworld_'+task_name not in ["metaworld_pick-out-of-hole-v2" ,"metaworld_pick-place-v2", "metaworld_pick-place-wall-v2" ,"metaworld_plate-slide-back-side-v2" ,"metaworld_plate-slide-back-v2", "metaworld_plate-slide-side-v2", "metaworld_plate-slide-v2" ,"metaworld_push-back-v2" , "metaworld_push-v2" ,"metaworld_push-wall-v2" ,"metaworld_reach-v2", "metaworld_reach-wall-v2",  "metaworld_shelf-place-v2", "metaworld_soccer-v2", "metaworld_stick-pull-v2", "metaworld_stick-push-v2",  "metaworld_sweep-v2",  "metaworld_sweep-into-v2", "metaworld_window-close-v2", "metaworld_window-open-v2"]:
		opal_hdnew, soft_length = read_data_csv_analyse([  # top500
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_use_dataset_rewards_0_seed_785/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_use_dataset_rewards_0_seed_786/logs/eval_loop/logs.csv',
		'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_use_dataset_rewards_0_seed_787/logs/eval_loop/logs.csv', ],
		smooth_rate)
	else:
		opal_hdnew, soft_length = read_data_csv_analyse([  # top500
			'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_hd_use_dataset_rewards_0_seed_785/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_hd_use_dataset_rewards_0_seed_786/logs/eval_loop/logs.csv',
			'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd_hd_use_dataset_rewards_0_seed_787/logs/eval_loop/logs.csv', ],
			smooth_rate)

	# opal_hdnew, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd599_use_dataset_rewards_0_seed_785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd599_use_dataset_rewards_0_seed_786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opal10truefixed_hd599_use_dataset_rewards_0_seed_787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	# opal_hdnew, soft_length = read_data_csv_analyse([  # top500
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd_fix599_use_dataset_rewards_1_seed_785/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd_fix599_use_dataset_rewards_1_seed_786/logs/eval_loop/logs.csv',
	# 	'/data3/zj/optimal_transport_reward/results_138/results/metaworld_' + task_name + '/opalhd_fix599_use_dataset_rewards_1_seed_787/logs/eval_loop/logs.csv', ],
	# 	smooth_rate)
	# pthd2, soft_length = read_data_txt_analyse([
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/test/185/progress.txt',
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/test/186/progress.txt','/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/test/187/progress.txt',],
	# 	smooth_rate)

	pthd40qeries_hd_799, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40testhd/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40testhd/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40testhd/787/progress.txt', ],
		smooth_rate)
	pthd40qeries, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT40/787/progress.txt', ],
		smooth_rate)

	pthd70qeries, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT70test/785/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT70test/786/progress.txt',
		'/data3/zj/optimal_transport_reward/ptresults_138/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/PT70test/787/progress.txt', ],
		smooth_rate)
	cuttop70, soft_length = read_data_txt_analyse([  # top500
		'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queriescut/385/progress.txt',
		'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queriescut/386/progress.txt','/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/10queriescut/387/progress.txt', ],
		smooth_rate)
	# pthd10qeries_hd
	datas = [original_reward,original_reward_hd_07099,pthd10qeries,pthd10qeries_hd_799,pthd100qeries,pthd100qeries_hd_799,pthd100qeries_hd2_799,random,opal,opal_hd2,opal_hd3,top10bc]
	datas = [original_reward,opal,opal2,opal_hd,opal_hd2,opal_hd3]
	datas = [original_reward,opal2,opal_hd3,pthd10qeries,pthd10qeries_hd_799]
	datas = [original_reward,pthd10qeries,pthd10qeries_hd_799]
	datas = [original_reward,oppo,otr,opal2,opal3,opal_hdnew,pthd10qeries,opal_hd3,pthd10qeries_hd_799]

	# datas=[original_reward,otr,cuttop70,pthd10qeries,pthd10qeries_hd_799,pthd40qeries,pthd40qeries_hd_799]
	datas=[original_reward,random,top10bc,otr,oppo]
	datas = [original_reward, pthd10qeries, cuttop70]
	datas = [original_reward,opal2,opal_hd3,pthd10qeries,pthd10qeries_hd_799]
	# datas=[original_reward,original_reward_hd_07099,pthd10qeries,pthd10qeries_hd_799,pthd40qeries,pthd40qeries_hd_799,pthd70qeries,pthd70qeries_hd_799,pthd100qeries,pthd100qeries_hd_799]#
	# datas = [original_reward,opal2,opal_hd3,pthd10qeries,pthd10qeries_hd_799]
	# datas = [original_reward,pthd10qeries,pthd10qeries_hd_799,pthd10qeries_hd_positive,opal]

	# datas = [original_reward,original_reward_hd_07099,pthd10qeries,pthd10qeries_hd_799,random,pthd100qeries,pthd100qeries_hd_799]
	dataset_name = task_name
	true_data = np.load('./data/'+dataset_name+'/data_randgoal_08_50_08_batch.npy',allow_pickle=True).tolist()
	max_return = 1
	for i in range(1000):
		current_return = np.sum([true_data['rewards'][i*500:(i+1)*500]])
		max_return = max(max_return,current_return)

	means,distances = [],[]
	print(dataset_name)
	# max_return = 1
	for i in range(len(datas)):
		mean = np.mean(datas[i][0][-20:])
		interval_distance = np.mean(datas[i][1][-20:])
		means.append(mean/ max_return)
		distances.append(interval_distance/ max_return)
	print(['%.2f$~\pm~$%.2f & ' % (m, d ) for (m, d) in zip(means, distances)])
	return means,distances
	# print("%.2f" % average_return)
	# plot_fig_save([ original_reward,learned50,ones,opal], [0, 1, 2, 3, 4, 5, 6, 7,8,9],
	# 				   ['Original Reward','Ours random 50','Ones','OPAL'],'Return',task_name)

# def plot_single_task_2(task_name):
# 	task_name = task_name.split('_')[1]
# 	original_reward, soft_length = read_data_csv([
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_285/logs/eval_loop/logs.csv',
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_286/logs/eval_loop/logs.csv','/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_287/logs/eval_loop/logs.csv', ],
# 												 smooth_rate)
# 	learned50, soft_length = read_data_csv([
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_385/logs/eval_loop/logs.csv',
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_386/logs/eval_loop/logs.csv','/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_387/logs/eval_loop/logs.csv', ],
# 												 smooth_rate)
#
# 	ones, soft_length = read_data_csv([
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_385/logs/eval_loop/logs.csv',
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_386/logs/eval_loop/logs.csv',
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_387/logs/eval_loop/logs.csv', ],
# 		smooth_rate)
#
#
# 	plot_fig_save([ original_reward,learned50,ones], [0, 1, 2, 3, 4, 5, 6, 7,8,9],
# 					   ['Original Reward','Ours random 50','Ones'],'Return',task_name)

if __name__=='__main__':
	#, "metaworld_button-press-topdown-wall-v2"286#, "metaworld_dial-turn-v2"287 # , "metaworld_button-press-wall-v2" 285-287
	# "metaworld_shelf-place-v2", "metaworld_stick-pull-v2"
	names=[]
	names+=[ "metaworld_assembly-v2", "metaworld_basketball-v2", "metaworld_bin-picking-v2", "metaworld_box-close-v2" ,"metaworld_button-press-topdown-v2"]
	names+=[ "metaworld_button-press-v2", "metaworld_coffee-button-v2" ,"metaworld_coffee-pull-v2" ,"metaworld_coffee-push-v2", "metaworld_disassemble-v2", "metaworld_door-close-v2"   ]
	names+=[ "metaworld_door-lock-v2", "metaworld_door-open-v2", "metaworld_door-unlock-v2", "metaworld_drawer-close-v2", "metaworld_drawer-open-v2", "metaworld_faucet-close-v2" ,]
	names+=["metaworld_faucet-open-v2","metaworld_hammer-v2", "metaworld_hand-insert-v2", "metaworld_handle-press-side-v2", "metaworld_handle-press-v2", "metaworld_handle-pull-side-v2", "metaworld_handle-pull-v2" ,"metaworld_lever-pull-v2"  ]
	names+=["metaworld_peg-insert-side-v2", "metaworld_peg-unplug-side-v2", "metaworld_pick-out-of-hole-v2" ,"metaworld_pick-place-v2", "metaworld_pick-place-wall-v2" ,"metaworld_plate-slide-back-side-v2" ,"metaworld_plate-slide-back-v2"  ]
	names+=["metaworld_plate-slide-side-v2", "metaworld_plate-slide-v2", "metaworld_push-back-v2",  "metaworld_push-v2" ,"metaworld_push-wall-v2", "metaworld_reach-v2" ,"metaworld_reach-wall-v2"  ]
	names+=[ "metaworld_soccer-v2", "metaworld_stick-push-v2"  ,"metaworld_sweep-v2",  "metaworld_sweep-into-v2", "metaworld_window-close-v2", "metaworld_window-open-v2"  ]
	# names=['metaworld_push-v2']
	names += ["metaworld_button-press-topdown-wall-v2", "metaworld_dial-turn-v2", "metaworld_button-press-wall-v2",
			   "metaworld_shelf-place-v2", "metaworld_stick-pull-v2"]
	# names.remove("metaworld_door-lock-v2")
	# names.remove("metaworld_door-open-v2")
	# names.remove("metaworld_door-unlock-v2")
	# names.remove("metaworld_faucet-close-v2")
	# names.remove("metaworld_faucet-open-v2")
	# names.remove("metaworld_handle-pull-side-v2")
	# names.remove("metaworld_lever-pull-v2")
	# names.remove("metaworld_plate-slide-v2")
	# names.remove("metaworld_window-close-v2")
	# names.remove("metaworld_stick-pull-v2")
	# for n in names:
	# 	true_data = np.load('./data/' + n.split('_')[1] + '/data_randgoal_08_50_08_batch.npy', allow_pickle=True).tolist()
	# 	max_return = 1
	# 	returns=[]
	# 	for i in range(1000):
	# 		current_return = np.sum([true_data['rewards'][i * 500:(i + 1) * 500]])
	# 		returns.append(current_return)
	# 		max_return = max(max_return, current_return)
	# 	average_return = np.mean(returns)
	# 	print(n.split('_')[1])
	# 	print(' @@@%.2f$~\pm~$%.2f &&& ' % (average_return,max_return))
	# return
	means_all,distances_all = [],[]
	for n in names:
		m,d=plot_single_task(n)
		means_all.append(m)
		distances_all.append(d)
	means_all,distances_all=np.array(means_all),np.array(distances_all)
	print(means_all.shape)
	print(np.mean(means_all,0),np.mean(distances_all,0))
	# for i in len(means_all[0]):


	# names2=[]
	# names2+=["metaworld_button-press-topdown-wall-v2", "metaworld_dial-turn-v2" ,"metaworld_button-press-wall-v2" ,"metaworld_shelf-place-v2" ,"metaworld_stick-pull-v2"]
	# for n in names2:
	# 	plot_single_task(n)

