import json
import matplotlib.pyplot as plt
import numpy as np
import pandas
import seaborn
from plot_utils import *
import os
smooth_rate = 30

def plot_single_task(task_name):
	task_name = task_name.split('_')[1]


	original_reward, soft_length = read_data_txt_analyse([
		'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/original/replay_fixed_original_reward/385/progress.txt',
		'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/original/replay_fixed_original_reward/386/progress.txt',
		'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/original/replay_fixed_original_reward/387/progress.txt', ],
		smooth_rate)
	# pthd2, soft_length = read_data_txt_analyse([
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/test/185/progress.txt',
	# 	'/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/test/186/progress.txt','/data3/zj/PreferenceTransformer/logs/tb/metaworld_' + task_name + '/reward_True_PrefTransformer/test/187/progress.txt',],
	# 	smooth_rate)


	datas = [original_reward]
	dataset_name = task_name
	true_data = np.load('./data/'+dataset_name+'/data_randgoal_08_50_08_batch.npy',allow_pickle=True).tolist()
	max_return = 1
	for i in range(1000):
		current_return = np.sum([true_data['rewards'][i*500:(i+1)*500]])
		max_return = max(max_return,current_return)

	means,distances = [],[]
	print(dataset_name)
	for i in range(len(datas)):
		mean = np.mean(datas[i][0][-5:])
		interval_distance = np.mean(datas[i][1][-5:])
		means.append(mean/ max_return)
		distances.append(interval_distance/ max_return)
	print(['%.2f$~\pm~$%.2f & ' % (m, d ) for (m, d) in zip(means, distances)])
	return means,distances
	# print("%.2f" % average_return)
	# plot_fig_save([ original_reward,learned50,ones,opal], [0, 1, 2, 3, 4, 5, 6, 7,8,9],
	# 				   ['Original Reward','Ours random 50','Ones','OPAL'],'Return',task_name)

# def plot_single_task_2(task_name):
# 	task_name = task_name.split('_')[1]
# 	original_reward, soft_length = read_data_csv([
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_285/logs/eval_loop/logs.csv',
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_286/logs/eval_loop/logs.csv','/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/ori_08_200_08_use_dataset_rewards_1_seed_287/logs/eval_loop/logs.csv', ],
# 												 smooth_rate)
# 	learned50, soft_length = read_data_csv([
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_385/logs/eval_loop/logs.csv',
# 													 '/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_386/logs/eval_loop/logs.csv','/data3/zj/optimal_transport_reward/results/metaworld_'+task_name+'/learned50_08_200_08_use_dataset_rewards_1_seed_387/logs/eval_loop/logs.csv', ],
# 												 smooth_rate)
#
# 	ones, soft_length = read_data_csv([
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_385/logs/eval_loop/logs.csv',
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_386/logs/eval_loop/logs.csv',
# 		'/data3/zj/optimal_transport_reward/results/metaworld_' + task_name + '/ones_08_200_08_use_dataset_rewards_1_seed_387/logs/eval_loop/logs.csv', ],
# 		smooth_rate)
#
#
# 	plot_fig_save([ original_reward,learned50,ones], [0, 1, 2, 3, 4, 5, 6, 7,8,9],
# 					   ['Original Reward','Ours random 50','Ones'],'Return',task_name)

if __name__=='__main__':
	#, "metaworld_button-press-topdown-wall-v2"286#, "metaworld_dial-turn-v2"287 # , "metaworld_button-press-wall-v2" 285-287
	# "metaworld_shelf-place-v2", "metaworld_stick-pull-v2"
	names=[]
	names+=[ "metaworld_reach-v2", "metaworld_push-v2" ,"metaworld_pick-place-v2", "metaworld_hammer-v2", "metaworld_basketball-v2" ,"metaworld_soccer-v2"]
	# names+=[ "metaworld_door-lock-v2", "metaworld_door-open-v2", "metaworld_door-unlock-v2", "metaworld_drawer-close-v2", "metaworld_drawer-open-v2", "metaworld_faucet-close-v2" ,"metaworld_faucet-open-v2"]
	# names+=["metaworld_hammer-v2", "metaworld_hand-insert-v2", "metaworld_handle-press-side-v2", "metaworld_handle-press-v2", "metaworld_handle-pull-side-v2", "metaworld_handle-pull-v2" ,"metaworld_lever-pull-v2"  ]
	# names+=["metaworld_peg-insert-side-v2", "metaworld_peg-unplug-side-v2", "metaworld_pick-out-of-hole-v2" ,"metaworld_pick-place-v2", "metaworld_pick-place-wall-v2" ,"metaworld_plate-slide-back-side-v2" ,"metaworld_plate-slide-back-v2"  ]
	# names+=["metaworld_plate-slide-side-v2", "metaworld_plate-slide-v2", "metaworld_push-back-v2",  "metaworld_push-v2" ,"metaworld_push-wall-v2", "metaworld_reach-v2" ,"metaworld_reach-wall-v2"  ]
	# names+=[ "metaworld_soccer-v2", "metaworld_stick-push-v2"  ,"metaworld_sweep-v2",  "metaworld_sweep-into-v2", "metaworld_window-close-v2", "metaworld_window-open-v2"  ]
	# names += ["metaworld_button-press-topdown-wall-v2", "metaworld_dial-turn-v2", "metaworld_button-press-wall-v2",
	# 		   "metaworld_shelf-place-v2", "metaworld_stick-pull-v2"]
	means_all,distances_all = [],[]
	for n in names:
		m,d=plot_single_task(n)
		means_all.append(m)
		distances_all.append(d)
	means_all,distances_all=np.array(means_all),np.array(distances_all)
	print(means_all.shape)
	print(np.mean(means_all,0),np.mean(distances_all,0))
	# for i in len(means_all[0]):


	# names2=[]
	# names2+=["metaworld_button-press-topdown-wall-v2", "metaworld_dial-turn-v2" ,"metaworld_button-press-wall-v2" ,"metaworld_shelf-place-v2" ,"metaworld_stick-pull-v2"]
	# for n in names2:
	# 	plot_single_task(n)