#!/bin/bash
#   # Script to reproduce results
#
# Foldername="0723_offline_meta_rl_qwer"
# mkdir out_logs/${Foldername} &> /dev/null
# maze2d-large-dense-v1
# antmaze-large-diverse-v0
# /data3/zj/optimal_transport_reward/reward_learning/rewards/ensemble_antmaze-large-diverse-v0_initial_pairs_5_num_queries_5_num_iter_20_retrain_num_iter_20_voi_myucb_seed_15_round_num_5.npy
# /data3/zj/optimal_transport_reward/reward_learning/rewards/ensemble_antmaze-large-diverse-v0_initial_pairs_5_num_queries_5_num_iter_20_retrain_num_iter_20_voi_dis_seed_5_round_num_9.npy
# /data3/zj/optimal_transport_reward/reward_learning/rewards/ensemble_antmaze-large-diverse-v0_initial_pairs_5_num_queries_5_num_iter_20_retrain_num_iter_20_voi_contrastive_seed_25_round_num_9.npy


#sleep 4800

  declare -a use_dataset_rewards=("1" )
  declare -a prefixes=( "opal101371" )
  declare  -a seeds=("785" "786" "787")
     declare  -a task_names=(  "metaworld_assembly-v2" "metaworld_basketball-v2" "metaworld_bin-picking-v2" "metaworld_box-close-v2" "metaworld_button-press-topdown-v2" "metaworld_button-press-topdown-wall-v2" "metaworld_dial-turn-v2")

 reward_file="None"
 for  task_name in "${task_names[@]}"
 do
 mkdir out_logs/${task_name} &> /dev/null
 done
## sleep 4300
 n=0
 gpunum=7
 for use_dataset_reward in "${use_dataset_rewards[@]}"
 do
 for seed in "${seeds[@]}"
 do
 for prefix in "${prefixes[@]}"
 do
 for  task_name in "${task_names[@]}"
 do
 CUDA_VISIBLE_DEVICES=${n}   XLA_PYTHON_CLIENT_PREALLOCATE=false nohup python -m otr.learn_reward \
  --workdir /data3/zj/optimal_transport_reward/results/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed} \
  --config /data3/zj/optimal_transport_reward/otr/configs/otr_iql_metaworld.py \
  --config.expert_dataset_name=${task_name} \
  --config.k=700 \
  --config.offline_dataset_name=${task_name} \
  --config.use_dataset_reward=${use_dataset_reward} \
   --config.seed=${seed}  \
   >& out_logs/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed}.txt &
  n=$[($n+1) % ${gpunum}]
 sleep 1
 done
 done
 done
 done

sleep 4300


  declare -a use_dataset_rewards=("1")
  declare -a prefixes=("opal101371"  )
  declare  -a seeds=("785" "786" "787")
     declare  -a task_names=( "metaworld_button-press-v2" "metaworld_button-press-wall-v2" "metaworld_coffee-button-v2" "metaworld_coffee-pull-v2" "metaworld_coffee-push-v2" "metaworld_disassemble-v2" "metaworld_door-close-v2" )
 reward_file="None"
 for  task_name in "${task_names[@]}"
 do
 mkdir out_logs/${task_name} &> /dev/null
 done
## sleep 4300
# n=0
 gpunum=7
 for use_dataset_reward in "${use_dataset_rewards[@]}"
 do
 for seed in "${seeds[@]}"
 do
 for prefix in "${prefixes[@]}"
 do
 for  task_name in "${task_names[@]}"
 do
 CUDA_VISIBLE_DEVICES=${n}   XLA_PYTHON_CLIENT_PREALLOCATE=false nohup python -m otr.learn_reward \
  --workdir /data3/zj/optimal_transport_reward/results/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed} \
  --config /data3/zj/optimal_transport_reward/otr/configs/otr_iql_metaworld.py \
  --config.expert_dataset_name=${task_name} \
  --config.k=700 \
  --config.offline_dataset_name=${task_name} \
  --config.use_dataset_reward=${use_dataset_reward} \
   --config.seed=${seed}  \
   >& out_logs/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed}.txt &
  n=$[($n+1) % ${gpunum}]
 sleep 1
 done
 done
 done
 done

sleep 4300





   declare -a use_dataset_rewards=( "1")
  declare -a prefixes=("opal101371"  )
  declare  -a seeds=("785" "786" "787")
     declare  -a task_names=(   "metaworld_door-lock-v2" "metaworld_door-open-v2" "metaworld_door-unlock-v2" "metaworld_drawer-close-v2" "metaworld_drawer-open-v2" "metaworld_faucet-close-v2" "metaworld_faucet-open-v2")
 reward_file="None"
 for  task_name in "${task_names[@]}"
 do
 mkdir out_logs/${task_name} &> /dev/null
 done
## sleep 4300
# n=0
 gpunum=7
 for use_dataset_reward in "${use_dataset_rewards[@]}"
 do
 for seed in "${seeds[@]}"
 do
 for prefix in "${prefixes[@]}"
 do
 for  task_name in "${task_names[@]}"
 do
 CUDA_VISIBLE_DEVICES=${n}   XLA_PYTHON_CLIENT_PREALLOCATE=false nohup python -m otr.learn_reward \
  --workdir /data3/zj/optimal_transport_reward/results/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed} \
  --config /data3/zj/optimal_transport_reward/otr/configs/otr_iql_metaworld.py \
  --config.expert_dataset_name=${task_name} \
  --config.k=700 \
  --config.offline_dataset_name=${task_name} \
  --config.use_dataset_reward=${use_dataset_reward} \
   --config.seed=${seed}  \
   >& out_logs/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed}.txt &
  n=$[($n+1) % ${gpunum}]
 sleep 1
 done
 done
 done
 done

sleep 4300

   declare -a use_dataset_rewards=( "1" )
  declare -a prefixes=("opal101371"  )
  declare  -a seeds=("785" "786" "787" )
     declare  -a task_names=(  "metaworld_hammer-v2" "metaworld_hand-insert-v2" "metaworld_handle-press-side-v2" "metaworld_handle-press-v2" "metaworld_handle-pull-side-v2" "metaworld_handle-pull-v2" "metaworld_lever-pull-v2")
 reward_file="None"
 for  task_name in "${task_names[@]}"
 do
 mkdir out_logs/${task_name} &> /dev/null
 done
## sleep 4300
# n=0
 gpunum=7
 for use_dataset_reward in "${use_dataset_rewards[@]}"
 do
 for seed in "${seeds[@]}"
 do
 for prefix in "${prefixes[@]}"
 do
 for  task_name in "${task_names[@]}"
 do
 CUDA_VISIBLE_DEVICES=${n}   XLA_PYTHON_CLIENT_PREALLOCATE=false nohup python -m otr.learn_reward \
  --workdir /data3/zj/optimal_transport_reward/results/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed} \
  --config /data3/zj/optimal_transport_reward/otr/configs/otr_iql_metaworld.py \
  --config.expert_dataset_name=${task_name} \
  --config.k=700 \
  --config.offline_dataset_name=${task_name} \
  --config.use_dataset_reward=${use_dataset_reward} \
   --config.seed=${seed}  \
   >& out_logs/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed}.txt &
  n=$[($n+1) % ${gpunum}]
 sleep 1
 done
 done
 done
 done

sleep 4300



  declare -a use_dataset_rewards=( "1")
  declare -a prefixes=("opal101371"  )
  declare  -a seeds=("785" "786" "787" )
    declare  -a task_names=( "metaworld_peg-insert-side-v2" "metaworld_peg-unplug-side-v2" "metaworld_pick-out-of-hole-v2" "metaworld_pick-place-v2" "metaworld_pick-place-wall-v2" "metaworld_plate-slide-back-side-v2" "metaworld_plate-slide-back-v2" )
 reward_file="None"
 for  task_name in "${task_names[@]}"
 do
 mkdir out_logs/${task_name} &> /dev/null
 done
## sleep 4300
# n=0
 gpunum=7
 for use_dataset_reward in "${use_dataset_rewards[@]}"
 do
 for seed in "${seeds[@]}"
 do
 for prefix in "${prefixes[@]}"
 do
 for  task_name in "${task_names[@]}"
 do
 CUDA_VISIBLE_DEVICES=${n}   XLA_PYTHON_CLIENT_PREALLOCATE=false nohup python -m otr.learn_reward \
  --workdir /data3/zj/optimal_transport_reward/results/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed} \
  --config /data3/zj/optimal_transport_reward/otr/configs/otr_iql_metaworld.py \
  --config.expert_dataset_name=${task_name} \
  --config.k=700 \
  --config.offline_dataset_name=${task_name} \
  --config.use_dataset_reward=${use_dataset_reward} \
   --config.seed=${seed}  \
   >& out_logs/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed}.txt &
  n=$[($n+1) % ${gpunum}]
 sleep 1
 done
 done
 done
 done
sleep 4300



  declare -a use_dataset_rewards=( "1")
  declare -a prefixes=("opal101371"  )
  declare  -a seeds=("785" "786" "787" )
    declare  -a task_names=("metaworld_plate-slide-side-v2" "metaworld_plate-slide-v2" "metaworld_push-back-v2"  "metaworld_push-v2" "metaworld_push-wall-v2" "metaworld_reach-v2" "metaworld_reach-wall-v2" )
 reward_file="None"
 for  task_name in "${task_names[@]}"
 do
 mkdir out_logs/${task_name} &> /dev/null
 done
## sleep 4300
# n=0
 gpunum=7
 for use_dataset_reward in "${use_dataset_rewards[@]}"
 do
 for seed in "${seeds[@]}"
 do
 for prefix in "${prefixes[@]}"
 do
 for  task_name in "${task_names[@]}"
 do
 CUDA_VISIBLE_DEVICES=${n}   XLA_PYTHON_CLIENT_PREALLOCATE=false nohup python -m otr.learn_reward \
  --workdir /data3/zj/optimal_transport_reward/results/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed} \
  --config /data3/zj/optimal_transport_reward/otr/configs/otr_iql_metaworld.py \
  --config.expert_dataset_name=${task_name} \
  --config.k=700 \
  --config.offline_dataset_name=${task_name} \
  --config.use_dataset_reward=${use_dataset_reward} \
   --config.seed=${seed}  \
   >& out_logs/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed}.txt &
  n=$[($n+1) % ${gpunum}]
 sleep 1
 done
 done
 done
 done
 sleep 4300



  declare -a use_dataset_rewards=( "1")
  declare -a prefixes=("opal101371"  )
  declare  -a seeds=("785" "786" "787" )
    declare  -a task_names=("metaworld_shelf-place-v2" "metaworld_soccer-v2" "metaworld_stick-pull-v2" "metaworld_stick-push-v2"  "metaworld_sweep-v2"  "metaworld_sweep-into-v2" "metaworld_window-close-v2" "metaworld_window-open-v2" )
 reward_file="None"
 for  task_name in "${task_names[@]}"
 do
 mkdir out_logs/${task_name} &> /dev/null
 done
## sleep 4300
# n=0
 gpunum=7
 for use_dataset_reward in "${use_dataset_rewards[@]}"
 do
 for seed in "${seeds[@]}"
 do
 for prefix in "${prefixes[@]}"
 do
 for  task_name in "${task_names[@]}"
 do
 CUDA_VISIBLE_DEVICES=${n}   XLA_PYTHON_CLIENT_PREALLOCATE=false nohup python -m otr.learn_reward \
  --workdir /data3/zj/optimal_transport_reward/results/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed} \
  --config /data3/zj/optimal_transport_reward/otr/configs/otr_iql_metaworld.py \
  --config.expert_dataset_name=${task_name} \
  --config.k=700 \
  --config.offline_dataset_name=${task_name} \
  --config.use_dataset_reward=${use_dataset_reward} \
   --config.seed=${seed}  \
   >& out_logs/${task_name}/${prefix}_use_dataset_rewards_${use_dataset_reward}_seed_${seed}.txt &
  n=$[($n+1) % ${gpunum}]
 sleep 1
 done
 done
 done
 done

# Training: bash run_ml1.sh.
# To change to other environments, modify "datadirs" in line 700, as well as "env_name" in ./configs/cpeal-ml1.json.

# Plot training curves: See plot_new_ml1.py.
# data collection: python data_collection_ml1.py ./configs/ml1.json
# To change to other environments, modify "env_name" in ./configs/ml1.json.

# Training: bash run_ml1.sh.
# To change to other environments, modify "datadirs" in line 700, as well as "env_name" in ./configs/cpeal-ml1.json.

# Plot training curves: See plot_new_ml1.py.